package com.gic.qywx.self;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.net.HttpURLConnection;
import java.net.InetAddress;
import java.net.UnknownHostException;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import org.apache.commons.lang3.StringUtils;
import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.HttpVersion;
import org.apache.http.NameValuePair;
import org.apache.http.auth.AuthScope;
import org.apache.http.auth.UsernamePasswordCredentials;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.CredentialsProvider;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.conn.ClientConnectionManager;
import org.apache.http.conn.params.ConnManagerParams;
import org.apache.http.conn.params.ConnPerRouteBean;
import org.apache.http.conn.params.ConnRouteParams;
import org.apache.http.conn.scheme.PlainSocketFactory;
import org.apache.http.conn.scheme.Scheme;
import org.apache.http.conn.scheme.SchemeRegistry;
import org.apache.http.conn.ssl.SSLSocketFactory;
import org.apache.http.entity.StringEntity;
import org.apache.http.entity.mime.MultipartEntity;
import org.apache.http.entity.mime.content.ContentBody;
import org.apache.http.impl.client.AbstractHttpClient;
import org.apache.http.impl.client.BasicCredentialsProvider;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.impl.conn.tsccm.ThreadSafeClientConnManager;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.params.BasicHttpParams;
import org.apache.http.params.HttpConnectionParams;
import org.apache.http.params.HttpParams;
import org.apache.http.params.HttpProtocolParams;
import org.apache.http.protocol.HTTP;
import org.apache.http.util.EntityUtils;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import com.alibaba.fastjson.JSON;

public class HttpClient {
    private static Logger logger = LogManager.getLogger(HttpClient.class);

    private static Map<String,org.apache.http.client.HttpClient> map = new HashMap<>() ;
    //private static
    public static final int DEFAULT_MAX_CONNECTIONS = 1000;
    public static final int DEFAULT_MAX_ROUTE_CONNECTIONS = 100;
    public static final int DEFAULT_SOCKET_TIMEOUT = 20 * 1000;
    public static final int DEFAULT_CONNECT_TIMEOUT = 30 * 1000;
    public static final int DEFAULT_SOCKET_BUFFER_SIZE = 8192;

    protected static org.apache.http.client.HttpClient getHttpClient(String ip) {
        org.apache.http.client.HttpClient mHttpClient = map.get(ip) ;
        //logger.info("clientSize={}",map.size());
        if(null != mHttpClient) {
            return mHttpClient ;
        }
        /**
         * old version
         * **/
        if (null == mHttpClient) {
            synchronized (HttpClient.class) {
                mHttpClient = map.get(ip) ;
                if(null != mHttpClient) {
                    return mHttpClient ;
                }
                if (null == mHttpClient) {
                    HttpParams params = new BasicHttpParams();
                    HttpProtocolParams.setVersion(params, HttpVersion.HTTP_1_1);
                    HttpProtocolParams.setContentCharset(params, HTTP.UTF_8);

                    ConnManagerParams.setTimeout(params, DEFAULT_SOCKET_TIMEOUT);
                    ConnManagerParams.setMaxConnectionsPerRoute(params,
                            new ConnPerRouteBean(DEFAULT_MAX_ROUTE_CONNECTIONS));
                    ConnManagerParams.setMaxTotalConnections(params, DEFAULT_MAX_CONNECTIONS);

                    HttpConnectionParams.setConnectionTimeout(params, DEFAULT_CONNECT_TIMEOUT);
                    HttpConnectionParams.setSoTimeout(params, DEFAULT_SOCKET_TIMEOUT);
                    HttpConnectionParams.setTcpNoDelay(params, true);
                    HttpConnectionParams.setSoReuseaddr(params, true);
                    HttpConnectionParams.setSoKeepalive(params, true);
                    HttpConnectionParams.setSocketBufferSize(params, DEFAULT_SOCKET_BUFFER_SIZE);

                    SchemeRegistry schReg = new SchemeRegistry();
                    schReg.register(new Scheme("http", PlainSocketFactory.getSocketFactory(), 80));
                    schReg.register(new Scheme("https", SSLSocketFactory.getSocketFactory(), 443));

                    ClientConnectionManager conMgr = new ThreadSafeClientConnManager(params, schReg);
                    mHttpClient = new DefaultHttpClient(conMgr, params);
                    map.put(ip,mHttpClient) ;
                }
            }
        }
        return mHttpClient;
    }

    public static Map<String, Object> getWinxinResByJson(String url, String jsonStr, byte[] b , String ip) {
        return getWinxinResByJson(url, jsonStr, null,b , ip);
    }

    private static Map<String, Object> getWinxinResByJson(String url, String jsonStr, Map<String, String> header , byte[] b , String ip) {

        long begin = new Date().getTime();
        String resInfo = null;
        Map<String, Object> weixinMap = new HashMap<String, Object>();
        org.apache.http.client.HttpClient client = getHttpClient(ip);
        setIp(client,b) ;
        HttpPost post = new HttpPost(url);
        StringBuilder builder = new StringBuilder();

        if (null != header) {
            for (Entry<String, String> entry : header.entrySet()) {
                post.addHeader(entry.getKey(), entry.getValue());
            }
        }

        try {

            if (null != jsonStr) {
                post.setEntity(new StringEntity(jsonStr, "utf-8"));
            }
            HttpResponse response = client.execute(post);
            resInfo = EntityUtils.toString(response.getEntity(), "utf-8");

            weixinMap = JSON.parseObject(resInfo, Map.class);
        } catch (UnsupportedEncodingException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (ClientProtocolException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } finally {
            long end = new Date().getTime();
            if(StringUtils.isBlank(resInfo)) {
                logger.info("请求url={},req={},resp={},time={}" ,url, map , "企微返回为空" , (end - begin));
            }else {
                logger.info("请求url={},req={},resp={},time={}" ,url, map , resInfo , (end - begin));
            }
        }
        return weixinMap;
    }

    public static Map<String, Object> getWinxinResByFile(String url, Map<String, ContentBody> map , byte[] b , String ip) {

        long begin = new Date().getTime();
        String entityStr = null;
        MultipartEntity entity = new MultipartEntity();
        Iterator<String> iterator = map.keySet().iterator();
        while (iterator.hasNext()) {
            String keyString = iterator.next();
            entity.addPart(keyString, map.get(keyString));
        }

        Map<String, Object> obj = null;
        org.apache.http.client.HttpClient client = getHttpClient(ip);
        setIp(client,b) ;
        HttpPost post = new HttpPost(url);
        StringBuilder builder = new StringBuilder();

        try {
            post.setEntity(entity);
            HttpResponse response = client.execute(post);
            entityStr = EntityUtils.toString(response.getEntity(), "utf-8");

            obj = JSON.parseObject(entityStr, Map.class);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
            return new HashMap<String, Object>();
        } finally {
            long end = new Date().getTime();
            if(StringUtils.isBlank(entityStr)) {
                logger.info("file请求url={},req={},resp={},time={}" ,url, map , "企微返回为空" , (end - begin));
            }else {
                logger.info("file请求url={},req={},resp={},time={}" ,url, map , entityStr , (end - begin));
            }
        }
        return obj;
    }

    private static Map<String, Object> getHttpByGet(String url, String userName, String password , byte[] b , String ip) {
        Map<String, Object> map = new HashMap<String, Object>();
        org.apache.http.client.HttpClient client = getHttpClient(ip);
        setIp(client,b) ;
        if (userName != null && password != null) {
            CredentialsProvider credsProvider = new BasicCredentialsProvider();
            UsernamePasswordCredentials usernamePassword = new UsernamePasswordCredentials(userName, password);
            credsProvider.setCredentials(AuthScope.ANY, usernamePassword);
            ((AbstractHttpClient) client).setCredentialsProvider(credsProvider);
        }
        HttpGet get = new HttpGet(url);
        get.setHeader("Authorization", "Basic YWRtaW46YWRtaW4=");
        HttpResponse response = null;
        try {
            response = client.execute(get);
            map = doResponse(response);
        } catch (ClientProtocolException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            if (response != null) {
                try {
                    response.getEntity().getContent().close();
                } catch (IllegalStateException | IOException e) {
                    e.printStackTrace();
                }
            }
        }
        return map;

    }

    public static Map<String, Object> getHttpByGet(String url , byte[] b , String ip) {
        return getHttpByGet(url, null, null , b , ip);
    }

    private static Map<String, Object> doResponse(HttpResponse response) {
        Map<String, Object> map = new HashMap<String, Object>();
        String line = "";
        String result = null;
        String responseStr = "";
        int responseCode = 0;
        try {

            HttpEntity entity = response.getEntity();

            BufferedReader reader = new BufferedReader(new InputStreamReader(entity.getContent(), "UTF-8"), 8 * 1024);

            StringBuilder builder = new StringBuilder();

            responseCode = response.getStatusLine().getStatusCode();

            switch (responseCode) {
            // 请求成功
            case HttpURLConnection.HTTP_OK:
                while ((line = reader.readLine()) != null) {
                    builder.append(line);
                }
                responseStr = builder.toString();
                result = "请求成功";
                break;
            case HttpURLConnection.HTTP_BAD_REQUEST:
                while ((line = reader.readLine()) != null) {
                    builder.append(line);
                }
                responseStr = builder.toString();
                result = "错误请求";
                break;
            case HttpURLConnection.HTTP_INTERNAL_ERROR:
                result = "服务器端错误";
                break;
            case HttpURLConnection.HTTP_NOT_FOUND:
                result = "未找到指定的网址";
                break;
            case HttpURLConnection.HTTP_BAD_GATEWAY:
                result = "请求超时";
                break;
            default:
                break;
            }

        } catch (Exception e) {
            e.printStackTrace();
            map.put("code", HttpURLConnection.HTTP_BAD_GATEWAY);
            map.put("result", "无法连接网络，请检查网络设置");
            map.put("response", "");
        } finally {
            map.put("code", responseCode);
            map.put("result", result);
            map.put("response", responseStr);
        }

        return map;
    }
    
    private static void setIp(org.apache.http.client.HttpClient client , byte[] ip) {
       try {
            if(null != ip) {
                client.getParams().setParameter(ConnRouteParams.LOCAL_ADDRESS, InetAddress.getByAddress(ip)) ;
            }else {
                logger.info("IP为空");
            }
        } catch (UnknownHostException e2) {
            e2.printStackTrace();
        }
    }

}
