package com.gic.qywx.self;

import com.alibaba.fastjson.JSONObject;
import com.gic.haoban.manage.api.service.QywxSelfApiService;
import org.apache.http.entity.ContentType;
import org.apache.http.entity.mime.content.ByteArrayBody;
import org.apache.http.entity.mime.content.ContentBody;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;
import java.util.HashMap;
import java.util.Map;

public class QywxSelfApiServiceImpl  {

    private Logger logger = LogManager.getLogger(QywxSelfApiServiceImpl.class);

    public Map<String,Object> selfPost(String url, String json, String ip) {
        logger.info("自建post,url={},json={},{}", url, json,ip);
        Map<String, Object> map = HttpClient.getWinxinResByJson(url, json, getIp(ip) , ip);
        return map;
    }
    public Map<String,Object> selfGet(String url, String ip) {
        logger.info("自建get,url={},ip={}", url,ip);
        Map<String, Object> map = HttpClient.getHttpByGet(url, getIp(ip) , ip);
        return map;
    }
    public Map<String,Object> selfUpload(String url, String fileUrl, String fileName, String ip) {
        logger.info("自建upload,url={},fileUrl={},ip={}", url,fileUrl,ip);
        byte[] data = CommonUtil.getFileByte(fileUrl);
        Map<String, ContentBody> paramsMap = new HashMap<String, ContentBody>();
        paramsMap.put("media", new ByteArrayBody(data, ContentType.DEFAULT_BINARY, fileName));
        Map<String, Object> map = HttpClient.getWinxinResByFile(url, paramsMap, getIp(ip) , ip);
        return map;
    }
    public Map<String,Object> selfImage(String url, String fileName, String ip , byte[] data) {
        logger.info("自建upload-data,url={},ip={}", url,ip);
        Map<String, ContentBody> paramsMap = new HashMap<String, ContentBody>();
        paramsMap.put("media", new ByteArrayBody(data, ContentType.DEFAULT_BINARY, fileName));
        Map<String, Object> map = HttpClient.getWinxinResByFile(url, paramsMap, getIp(ip) , ip);
        return map;
    }

    // 必须是内网ip
    private byte[] getIp(String ip) {
        if(StringUtils.isEmpty(ip)) {
            return null ;
        }
        String[] arr = ip.split("\\.");
        byte[] b = new byte[] {Integer.valueOf(arr[0]).byteValue(),  Integer.valueOf(arr[1]).byteValue(),Integer.valueOf(arr[2]).byteValue(),Integer.valueOf(arr[3]).byteValue()};
        return b;
    }
}
